gcc_update revision 1.1.1.5.2.2 1 1.1 mrg #! /bin/sh
2 1.1 mrg #
3 1.1.1.2 mrg # Update a local Subversion, Git or Mercurial tree from the GCC
4 1.1.1.2 mrg # repository, with an emphasis on treating generated files correctly, so
5 1.1.1.2 mrg # that autoconf, gperf et al are not required for the ``end'' user.
6 1.1 mrg #
7 1.1.1.5.2.2 pgoyette # (C) 1998, 1999, 2000, 2001, 2002, 2003, 2004, 2005, 2006, 2007, 2009,
8 1.1.1.5.2.2 pgoyette # 2010, 2011, 2012, 2013, 2014, 2015, 2017 Free Software Foundation
9 1.1.1.5.2.2 pgoyette # Originally by Gerald Pfeifer <gerald (at] pfeifer.com>, August 1998.
10 1.1 mrg #
11 1.1 mrg # This script is Free Software, and it can be copied, distributed and
12 1.1 mrg # modified as defined in the GNU General Public License. A copy of
13 1.1 mrg # its license can be downloaded from http://www.gnu.org/copyleft/gpl.html
14 1.1 mrg #
15 1.1 mrg #
16 1.1.1.2 mrg # By default all command-line options are passed to `svn update` or `hg/git
17 1.1.1.2 mrg # pull` in addition to $UPDATE_OPTIONS (defined below). If the first parameter
18 1.1 mrg # reads --nostdflags, $UPDATE_OPTIONS as well as this parameter itself
19 1.1 mrg # are omitted.
20 1.1 mrg #
21 1.1 mrg # If the first parameter reads --patch, the second parameter is considered
22 1.1 mrg # a patch file.
23 1.1 mrg #
24 1.1 mrg # If the first parameter is --touch, no svn operation will be performed,
25 1.1 mrg # only generated files that appear to be out of date in the local tree
26 1.1 mrg # will be touched.
27 1.1 mrg #
28 1.1 mrg # If the first parameter is --list, a list of the generated files and
29 1.1 mrg # their dependencies will be printed; --help prints this message.
30 1.1 mrg #
31 1.1 mrg # If the first parameter is --silent, this script prints nothing other
32 1.1 mrg # than error messages; the second parameter is then interpreted as above.
33 1.1 mrg #
34 1.1 mrg # Examples:
35 1.1 mrg #
36 1.1 mrg # contrib/gcc_update -r 8712
37 1.1 mrg # contrib/gcc_update --patch some-patch
38 1.1 mrg # contrib/gcc_update --touch
39 1.1 mrg # contrib/gcc_update --list
40 1.1 mrg
41 1.1 mrg
42 1.1.1.2 mrg # Default options used when updating (none).
43 1.1 mrg UPDATE_OPTIONS=""
44 1.1 mrg
45 1.1.1.2 mrg # Set the locale to C to make this script work for users with foreign
46 1.1.1.2 mrg # locale like e.g. French UTF-8.
47 1.1.1.2 mrg LANG=C
48 1.1.1.2 mrg LC_ALL=C
49 1.1.1.2 mrg export LANG LC_ALL
50 1.1.1.2 mrg
51 1.1 mrg ######## Anything below shouldn't be changed by regular users.
52 1.1 mrg
53 1.1 mrg # Arrange for the value of $0 to be available for functions
54 1.1 mrg self=$0
55 1.1 mrg
56 1.1 mrg # This function prints its arguments to standard output unless
57 1.1 mrg # "silent" is set.
58 1.1 mrg unset silent
59 1.1 mrg chat () {
60 1.1 mrg if [ -z "$silent" ]; then
61 1.1 mrg echo "$@"
62 1.1 mrg fi
63 1.1 mrg }
64 1.1 mrg
65 1.1 mrg # This function prints a list of all generated files, along with their
66 1.1 mrg # dependencies. Note that only one target is supported per line: the
67 1.1 mrg # colon is stripped from the output.
68 1.1 mrg files_and_dependencies () {
69 1.1 mrg sed -e 's/ *#.*//' -e '/^$/d' -e 's/://' <<\EOF
70 1.1 mrg # fixincludes
71 1.1 mrg fixincludes/configure: fixincludes/configure.ac fixincludes/aclocal.m4
72 1.1 mrg fixincludes/config.h.in: fixincludes/configure.ac fixincludes/aclocal.m4
73 1.1 mrg # intl library
74 1.1 mrg intl/plural.c: intl/plural.y
75 1.1 mrg intl/configure: intl/configure.ac intl/aclocal.m4
76 1.1 mrg intl/config.h.in: intl/configure.ac intl/aclocal.m4
77 1.1 mrg # Now, proceed to gcc automatically generated files
78 1.1 mrg gcc/configure: gcc/configure.ac
79 1.1 mrg gcc/cstamp-h.in: gcc/configure.ac
80 1.1 mrg gcc/config.in: gcc/cstamp-h.in
81 1.1 mrg gcc/fixinc/fixincl.x: gcc/fixinc/fixincl.tpl gcc/fixinc/inclhack.def
82 1.1.1.3 mrg gcc/config/aarch64/aarch64-tune.md: gcc/config/aarch64/aarch64-cores.def gcc/config/aarch64/gentune.sh
83 1.1.1.5.2.2 pgoyette gcc/config/arm/arm-tune.md: gcc/config/arm/arm-cpus.in gcc/config/arm/parsecpu.awk
84 1.1.1.5.2.2 pgoyette gcc/config/arm/arm-tables.opt: gcc/config/arm/arm-cpus.in gcc/config/arm/parsecpu.awk
85 1.1.1.5.2.2 pgoyette gcc/config/arm/arm-cpu.h: gcc/config/arm/arm-cpus.in gcc/config/arm/parsecpu.awk
86 1.1.1.5.2.2 pgoyette gcc/config/arm/arm-cpu-data.h: gcc/config/arm/arm-cpus.in gcc/config/arm/parsecpu.awk
87 1.1.1.5.2.2 pgoyette gcc/config/arm/arm-cpu-cdata.h: gcc/config/arm/arm-cpus.in gcc/config/arm/parsecpu.awk
88 1.1.1.2 mrg gcc/config/avr/avr-tables.opt: gcc/config/avr/avr-mcus.def gcc/config/avr/genopt.sh
89 1.1.1.2 mrg gcc/config/avr/t-multilib: gcc/config/avr/avr-mcus.def gcc/config/avr/genmultilib.awk
90 1.1.1.2 mrg gcc/config/c6x/c6x-tables.opt: gcc/config/c6x/c6x-isas.def gcc/config/c6x/genopt.sh
91 1.1.1.2 mrg gcc/config/c6x/c6x-sched.md: gcc/config/c6x/c6x-sched.md.in gcc/config/c6x/gensched.sh
92 1.1.1.2 mrg gcc/config/c6x/c6x-mult.md: gcc/config/c6x/c6x-mult.md.in gcc/config/c6x/genmult.sh
93 1.1.1.2 mrg gcc/config/m68k/m68k-tables.opt: gcc/config/m68k/m68k-devices.def gcc/config/m68k/m68k-isas.def gcc/config/m68k/m68k-microarchs.def gcc/config/m68k/genopt.sh
94 1.1.1.2 mrg gcc/config/mips/mips-tables.opt: gcc/config/mips/mips-cpus.def gcc/config/mips/genopt.sh
95 1.1.1.2 mrg gcc/config/rs6000/rs6000-tables.opt: gcc/config/rs6000/rs6000-cpus.def gcc/config/rs6000/genopt.sh
96 1.1.1.2 mrg gcc/config/tilegx/mul-tables.c: gcc/config/tilepro/gen-mul-tables.cc
97 1.1.1.2 mrg gcc/config/tilepro/mul-tables.c: gcc/config/tilepro/gen-mul-tables.cc
98 1.1 mrg # And then, language-specific files
99 1.1 mrg gcc/cp/cfns.h: gcc/cp/cfns.gperf
100 1.1 mrg # testsuite
101 1.1 mrg # Without this, _Pragma3.c can have a false negative.
102 1.1 mrg gcc/testsuite/gcc.dg/cpp/_Pragma3.c: gcc/testsuite/gcc.dg/cpp/mi1c.h
103 1.1 mrg # Similarly, without this, you will see:
104 1.1 mrg # direct2s.c:35: warning: current file is older than direct2.c
105 1.1 mrg gcc/testsuite/gcc.dg/cpp/direct2s.c: gcc/testsuite/gcc.dg/cpp/direct2.c
106 1.1 mrg # lto-plugin
107 1.1 mrg lto-plugin/configure: lto-plugin/configure.ac lto-plugin/aclocal.m4
108 1.1 mrg lto-plugin/Makefile.in: lto-plugin/Makefile.am lto-plugin/aclocal.m4
109 1.1 mrg # And libraries, at last
110 1.1 mrg libbanshee/configure: libbanshee/configure.ac
111 1.1 mrg libmudflap/configure: libmudflap/configure.ac
112 1.1 mrg libobjc/configure: libobjc/configure.ac
113 1.1 mrg zlib/aclocal.m4: zlib/configure.ac zlib/acinclude.m4
114 1.1 mrg zlib/Makefile.in: zlib/Makefile.am zlib/configure.ac zlib/aclocal.m4
115 1.1 mrg zlib/configure: zlib/configure.ac zlib/aclocal.m4
116 1.1 mrg fastjar/aclocal.m4: fastjar/configure.ac
117 1.1 mrg fastjar/Makefile.in: fastjar/Makefile.am fastjar/configure.ac fastjar/aclocal.m4
118 1.1 mrg fastjar/configure: fastjar/configure.ac fastjar/aclocal.m4
119 1.1 mrg boehm-gc/aclocal.m4: boehm-gc/configure.ac
120 1.1 mrg boehm-gc/Makefile.in: boehm-gc/Makefile.am boehm-gc/configure.ac boehm-gc/aclocal.m4
121 1.1 mrg boehm-gc/configure: boehm-gc/configure.ac boehm-gc/aclocal.m4
122 1.1 mrg libada/configure: libada/configure.ac
123 1.1 mrg libffi/aclocal.m4: libffi/configure.ac libffi/acinclude.m4
124 1.1 mrg libffi/Makefile.in: libffi/Makefile.am libffi/configure.ac libffi/aclocal.m4
125 1.1 mrg libffi/configure: libffi/configure.ac libffi/aclocal.m4
126 1.1 mrg libffi/fficonfig.h.in: libffi/configure.ac libffi/aclocal.m4
127 1.1 mrg libgfortran/aclocal.m4: libgfortran/configure.ac libgfortran/acinclude.m4
128 1.1 mrg libgfortran/Makefile.in: libgfortran/Makefile.am libgfortran/configure.ac libgfortran/aclocal.m4
129 1.1.1.2 mrg libquadmath/configure: libquadmath/configure.ac libquadmath/aclocal.m4
130 1.1.1.2 mrg libquadmath/aclocal.m4: libquadmath/configure.ac libquadmath/acinclude.m4
131 1.1.1.2 mrg libquadmath/Makefile.in: libquadmath/Makefile.am libquadmath/configure.ac libgfortran/aclocal.m4
132 1.1 mrg libgfortran/configure: libgfortran/configure.ac libgfortran/aclocal.m4
133 1.1 mrg libcpp/aclocal.m4: libcpp/configure.ac
134 1.1 mrg libcpp/Makefile.in: libcpp/configure.ac libcpp/aclocal.m4
135 1.1 mrg libcpp/configure: libcpp/configure.ac libcpp/aclocal.m4
136 1.1 mrg libgomp/aclocal.m4: libgomp/configure.ac libgomp/acinclude.m4
137 1.1.1.3 mrg libgomp/Makefile.am: libgomp/plugin/Makefrag.am
138 1.1 mrg libgomp/Makefile.in: libgomp/Makefile.am libgomp/aclocal.m4
139 1.1.1.3 mrg libgomp/testsuite/Makefile.in: libgomp/testsuite/Makefile.am libgomp/aclocal.m4
140 1.1.1.3 mrg libgomp/configure.ac: libgomp/plugin/configfrag.ac
141 1.1 mrg libgomp/configure: libgomp/configure.ac libgomp/aclocal.m4
142 1.1 mrg libgomp/config.h.in: libgomp/configure.ac libgomp/aclocal.m4
143 1.1.1.5.2.2 pgoyette libhsail-rt/aclocal.m4: libhsail-rt/configure.ac
144 1.1.1.5.2.2 pgoyette libhsail-rt/Makefile.in: libhsail-rt/Makefile.am libhsail-rt/aclocal.m4
145 1.1.1.5.2.2 pgoyette libhsail-rt/configure: libhsail-rt/configure.ac libhsail-rt/aclocal.m4
146 1.1.1.5.2.2 pgoyette libhsail-rt/target-config.h.in: libhsail-rt/configure.ac libhsail-rt/aclocal.m4
147 1.1.1.2 mrg libitm/aclocal.m4: libitm/configure.ac libitm/acinclude.m4
148 1.1.1.2 mrg libitm/Makefile.in: libitm/Makefile.am libitm/aclocal.m4
149 1.1.1.2 mrg libitm/testsuite/Makefile.in: libitm/testsuite/Makefile.am libitm/aclocal.m4
150 1.1.1.2 mrg libitm/configure: libitm/configure.ac libitm/aclocal.m4
151 1.1.1.2 mrg libitm/config.h.in: libitm/configure.ac libitm/aclocal.m4
152 1.1.1.2 mrg libatomic/aclocal.m4: libatomic/configure.ac libatomic/acinclude.m4
153 1.1.1.2 mrg libatomic/Makefile.in: libatomic/Makefile.am libatomic/aclocal.m4
154 1.1.1.2 mrg libatomic/testsuite/Makefile.in: libatomic/testsuite/Makefile.am libatomic/aclocal.m4
155 1.1.1.2 mrg libatomic/configure: libatomic/configure.ac libatomic/aclocal.m4
156 1.1.1.2 mrg libatomic/auto-config.h.in: libatomic/configure.ac libatomic/aclocal.m4
157 1.1.1.2 mrg libsanitizer/aclocal.m4: libsanitizer/configure.ac libsanitizer/acinclude.m4
158 1.1.1.2 mrg libsanitizer/Makefile.in: libsanitizer/Makefile.am libsanitizer/aclocal.m4
159 1.1.1.2 mrg libsanitizer/configure: libsanitizer/configure.ac libsanitizer/aclocal.m4
160 1.1.1.2 mrg libsanitizer/asan/Makefile.in: libsanitizer/asan/Makefile.am libsanitizer/aclocal.m4
161 1.1.1.2 mrg libsanitizer/interception/Makefile.in: libsanitizer/interception/Makefile.am libsanitizer/aclocal.m4
162 1.1.1.2 mrg libsanitizer/sanitizer_common/Makefile.in: libsanitizer/sanitizer_common/Makefile.am libsanitizer/aclocal.m4
163 1.1.1.3 mrg libvtv/aclocal.m4: libvtv/configure.ac libvtv/acinclude.m4
164 1.1.1.3 mrg libvtv/Makefile.in: libvtv/Makefile.am libvtv/aclocal.m4
165 1.1.1.3 mrg libvtv/configure: libvtv/configure.ac libvtv/aclocal.m4
166 1.1.1.3 mrg libcilkrts/aclocal.m4: libcilkrts/configure.ac
167 1.1.1.3 mrg libcilkrts/Makefile.in: libcilkrts/Makefile.am
168 1.1.1.3 mrg libcilkrts/configure: libcilkrts/configure.ac
169 1.1.1.3 mrg liboffloadmic/aclocal.m4: liboffloadmic/configure.ac
170 1.1.1.3 mrg liboffloadmic/Makefile.in: liboffloadmic/Makefile.am
171 1.1.1.3 mrg liboffloadmic/configure: liboffloadmic/configure.ac
172 1.1.1.3 mrg liboffloadmic/plugin/aclocal.m4: liboffloadmic/plugin/configure.ac
173 1.1.1.3 mrg liboffloadmic/plugin/Makefile.in: liboffloadmic/plugin/Makefile.am
174 1.1.1.3 mrg liboffloadmic/plugin/configure: liboffloadmic/plugin/configure.ac
175 1.1.1.5.2.1 pgoyette libbacktrace/aclocal.m4: libbacktrace/configure.ac
176 1.1.1.5.2.1 pgoyette libbacktrace/Makefile.in: libbacktrace/Makefile.am libbacktrace/aclocal.m4
177 1.1.1.5.2.1 pgoyette libbacktrace/configure: libbacktrace/configure.ac libbacktrace/aclocal.m4
178 1.1.1.5.2.1 pgoyette libbacktrace/config.h.in: libbacktrace/configure.ac libbacktrace/aclocal.m4
179 1.1 mrg # Top level
180 1.1 mrg Makefile.in: Makefile.tpl Makefile.def
181 1.1 mrg configure: configure.ac config/acx.m4
182 1.1 mrg EOF
183 1.1 mrg }
184 1.1 mrg
185 1.1 mrg
186 1.1 mrg # This function touches generated files such that the ``end'' user does
187 1.1 mrg # not have to rebuild them.
188 1.1 mrg touch_files () {
189 1.1 mrg rm -f Makefile.$$
190 1.1 mrg echo 'all: \' > Makefile.$$
191 1.1 mrg files_and_dependencies | sed 's, .*, \\,' >> Makefile.$$
192 1.1 mrg echo '; @true' >> Makefile.$$
193 1.1 mrg files_and_dependencies | sed 's, ,: ,' >> Makefile.$$
194 1.1 mrg files_and_dependencies | sed 's, .*, \\,' >> Makefile.$$
195 1.1 mrg echo ':' >> Makefile.$$
196 1.1 mrg echo ' @for f in $? $@; do test -f $$f || exit 0; done; \' >> Makefile.$$
197 1.1 mrg echo ' echo Touching $@...; \' >> Makefile.$$
198 1.1 mrg chat ' echo Touching $@... 1>&2; \' >> Makefile.$$
199 1.1 mrg echo ' touch $@' >> Makefile.$$
200 1.1 mrg files_and_dependencies | sed 's,[^ ]* ,,;s,$, :,' >> Makefile.$$
201 1.1 mrg
202 1.1 mrg # We would have to explicitly shut off the "Entering... Leaving..."
203 1.1 mrg # messages through "--no-print-directory" to handle the case when
204 1.1 mrg # we were called from a recursive invocation (i.e. "$(MAKE)" in a
205 1.1 mrg # Makefile, not just make). Passing only "-s" doesn't help then,
206 1.1 mrg # because make has helpfully added "-w" to MAKEFLAGS automatically.
207 1.1 mrg # Unfortunately we do not require GNU make other than for building
208 1.1 mrg # and testing, so let's just grep known text explicitly echoed by
209 1.1 mrg # the rule.
210 1.1 mrg while ${MAKE-make} -s -f Makefile.$$ all | grep Touching > /dev/null; do
211 1.1 mrg sleep 1
212 1.1 mrg done 2>&1
213 1.1 mrg rm -f Makefile.$$
214 1.1 mrg }
215 1.1 mrg
216 1.1 mrg
217 1.1 mrg # Whenever we update the tree or install a patch, we may be modifying
218 1.1 mrg # this script. By re-execing it, we ensure that the appropriate
219 1.1 mrg # dependencies and rules will be used.
220 1.1 mrg touch_files_reexec () {
221 1.1 mrg chat "Adjusting file timestamps"
222 1.1 mrg exec ${CONFIG_SHELL-/bin/sh} $self ${silent+"--silent"} --touch
223 1.1 mrg }
224 1.1 mrg
225 1.1 mrg # This functions applies a patch to an existing tree.
226 1.1 mrg apply_patch () {
227 1.1 mrg if [ -f "$1" ]; then
228 1.1 mrg echo "Applying patch file $1"
229 1.1 mrg case $1 in
230 1.1 mrg *gz)
231 1.1 mrg gzip -d -c "$1" | patch -p1 ;;
232 1.1 mrg *bz2)
233 1.1 mrg bzip2 -d -c "$1" | patch -p1 ;;
234 1.1 mrg *)
235 1.1 mrg patch -p1 < "$1";;
236 1.1 mrg esac
237 1.1 mrg fi
238 1.1 mrg touch_files_reexec
239 1.1 mrg }
240 1.1 mrg
241 1.1 mrg # Check whether this indeed looks like a local tree.
242 1.1 mrg if [ ! -f gcc/version.c ]; then
243 1.1 mrg echo "This does not seem to be a GCC tree!"
244 1.1 mrg exit
245 1.1 mrg fi
246 1.1 mrg
247 1.1 mrg case "$1" in
248 1.1 mrg --silent)
249 1.1 mrg silent=t
250 1.1 mrg shift
251 1.1 mrg ;;
252 1.1 mrg esac
253 1.1 mrg
254 1.1 mrg case "$1" in
255 1.1 mrg # First of all, check whether we are going to process a patch.
256 1.1 mrg --patch)
257 1.1 mrg if test "$#" != 2; then
258 1.1 mrg echo "$1" expects only one argument >&2
259 1.1 mrg exit 1
260 1.1 mrg fi
261 1.1 mrg apply_patch "${2}"
262 1.1 mrg exit $?
263 1.1 mrg ;;
264 1.1 mrg
265 1.1 mrg --touch)
266 1.1 mrg if test "$#" != 1; then
267 1.1 mrg echo "$1" does not expect any argument >&2
268 1.1 mrg exit 1
269 1.1 mrg fi
270 1.1 mrg touch_files
271 1.1 mrg exit $?
272 1.1 mrg ;;
273 1.1 mrg
274 1.1 mrg --list)
275 1.1 mrg if test "$#" != 1; then
276 1.1 mrg echo "$1" does not expect any argument >&2
277 1.1 mrg exit 1
278 1.1 mrg fi
279 1.1 mrg files_and_dependencies | sed 's/ /: /'
280 1.1 mrg exit $?
281 1.1 mrg ;;
282 1.1 mrg
283 1.1 mrg --help)
284 1.1 mrg sed -e '1,2d' -e '/^UPDATE_OPTIONS=/{i\
285 1.1 mrg \
286 1.1 mrg
287 1.1 mrg p
288 1.1 mrg }' \
289 1.1 mrg -e '/^$/,$d' -e 's/#//' -e 's/^ //' < $0
290 1.1 mrg exit $?
291 1.1 mrg ;;
292 1.1 mrg
293 1.1 mrg esac
294 1.1 mrg
295 1.1.1.2 mrg # Check for known version control systems.
296 1.1.1.2 mrg if [ -d .git ]; then
297 1.1.1.2 mrg GCC_GIT=${GCC_GIT-${GIT-git}}
298 1.1.1.2 mrg vcs_type="git"
299 1.1.1.2 mrg elif [ -d .hg ]; then
300 1.1.1.2 mrg GCC_HG=${GCC_HG-${HG-hg}}
301 1.1.1.2 mrg vcs_type="hg"
302 1.1.1.2 mrg elif [ -d .svn ]; then
303 1.1.1.2 mrg GCC_SVN=${GCC_SVN-${SVN-svn}}
304 1.1.1.2 mrg vcs_type="svn"
305 1.1.1.2 mrg else
306 1.1.1.2 mrg echo "This does not seem to be a GCC GIT/HG/SVN tree!"
307 1.1 mrg exit
308 1.1 mrg fi
309 1.1 mrg
310 1.1 mrg # Check command-line options
311 1.1 mrg if [ x"${1}"x = x"--nostdflags"x ]; then
312 1.1 mrg shift
313 1.1 mrg else
314 1.1 mrg set -- $UPDATE_OPTIONS ${1+"$@"}
315 1.1 mrg fi
316 1.1 mrg
317 1.1.1.2 mrg case $vcs_type in
318 1.1.1.2 mrg git)
319 1.1.1.2 mrg chat "Updating GIT tree"
320 1.1.1.2 mrg
321 1.1.1.2 mrg $GCC_GIT diff --quiet --exit-code HEAD
322 1.1.1.2 mrg if [ $? -ne 0 ]; then
323 1.1.1.2 mrg echo "Attempting to update a dirty git tree!" >&2
324 1.1.1.2 mrg echo "Commit or stash your changes first and retry." >&2
325 1.1.1.2 mrg exit 1
326 1.1.1.2 mrg fi
327 1.1.1.2 mrg
328 1.1.1.2 mrg $GCC_GIT pull ${silent+-q} --rebase ${1+"$@"}
329 1.1.1.2 mrg if [ $? -ne 0 ]; then
330 1.1.1.2 mrg (touch_files_reexec)
331 1.1.1.2 mrg echo "git pull of full tree failed." >&2
332 1.1.1.2 mrg exit 1
333 1.1.1.2 mrg fi
334 1.1.1.2 mrg
335 1.1.1.2 mrg revision=`$GCC_GIT log -n1 --pretty=%p:%t:%H`
336 1.1.1.2 mrg branch=`$GCC_GIT name-rev --name-only HEAD || :`
337 1.1.1.2 mrg ;;
338 1.1.1.2 mrg
339 1.1.1.2 mrg hg)
340 1.1.1.2 mrg chat "Updating HG tree"
341 1.1.1.2 mrg
342 1.1.1.2 mrg # Add -q so untracked files aren't listed.
343 1.1.1.2 mrg if [ `$GCC_HG status -q | wc -l` -gt 0 ]; then
344 1.1.1.2 mrg echo "Attempting to update a dirty hg tree!" >&2
345 1.1.1.2 mrg echo "Commit or revert your changes first and retry." >&2
346 1.1.1.2 mrg exit 1
347 1.1.1.2 mrg fi
348 1.1.1.2 mrg
349 1.1.1.2 mrg # Check for mq extension. mq patches must be popped so tip has
350 1.1.1.2 mrg # been converted from the SVN tree.
351 1.1.1.2 mrg if [ -d .hg/patches ] && [ `$GCC_HG qapplied | wc -l` -gt 0 ]; then
352 1.1.1.2 mrg # FIXME: Perhaps pop queue instead? We could do that since we
353 1.1.1.2 mrg # know the tree is clean.
354 1.1.1.2 mrg echo "Attempting to update hg tree with mq patches applied!" >&2
355 1.1.1.2 mrg echo "Pop your patches first and retry." >&2
356 1.1.1.2 mrg exit 1
357 1.1.1.2 mrg fi
358 1.1.1.2 mrg
359 1.1.1.2 mrg # Update tree, but make sure to only pull the default branch.
360 1.1.1.2 mrg # Otherwise all branches in the upstream repo are added, even if
361 1.1.1.2 mrg # only a single one has been cloned.
362 1.1.1.2 mrg $GCC_HG pull ${silent+-q} -r`$GCC_HG branch` ${1+"$@"}
363 1.1.1.2 mrg if [ $? -ne 0 ]; then
364 1.1.1.2 mrg (touch_files_reexec)
365 1.1.1.2 mrg echo "hg pull of full tree failed." >&2
366 1.1.1.2 mrg exit 1
367 1.1.1.2 mrg fi
368 1.1.1.2 mrg
369 1.1.1.2 mrg # Update tree. Needs to be done separately from pull so
370 1.1.1.2 mrg # gcc_update -rREV works.
371 1.1.1.2 mrg $GCC_HG update ${silent+-q} ${1+"$@"}
372 1.1.1.2 mrg if [ $? -ne 0 ]; then
373 1.1.1.2 mrg (touch_files_reexec)
374 1.1.1.2 mrg echo "hg update of full tree failed." >&2
375 1.1.1.2 mrg exit 1
376 1.1.1.2 mrg fi
377 1.1.1.2 mrg
378 1.1.1.2 mrg # Extract SVN revision corresponding to parents, as stored by
379 1.1.1.2 mrg # hg convert. Before hg 1.4.3, there's no template keyword
380 1.1.1.2 mrg # corresponding to the extra: tag, so need to use hg log --debug
381 1.1.1.2 mrg # to extract the info.
382 1.1.1.2 mrg parents=`$GCC_HG parents --template '{rev}'`
383 1.1.1.2 mrg convert_revision=`$GCC_HG log --debug -r$parents | \
384 1.1.1.2 mrg sed -ne "/^extra:.*convert_revision=svn:/ {
385 1.1.1.2 mrg s%^[^/]*/%%
386 1.1.1.2 mrg p
387 1.1.1.2 mrg }"`
388 1.1.1.2 mrg revision=`echo $convert_revision | sed -e 's/.*@//'`
389 1.1.1.2 mrg branch=`echo $convert_revision | sed -e 's%branches/%%' -e 's/@.*//'`
390 1.1.1.2 mrg ;;
391 1.1.1.2 mrg
392 1.1.1.2 mrg svn)
393 1.1.1.2 mrg chat "Updating SVN tree"
394 1.1.1.2 mrg
395 1.1.1.2 mrg $GCC_SVN ${silent+-q} --non-interactive update ${1+"$@"}
396 1.1.1.2 mrg if [ $? -ne 0 ]; then
397 1.1.1.2 mrg (touch_files_reexec)
398 1.1.1.2 mrg echo "SVN update of full tree failed." >&2
399 1.1.1.2 mrg exit 1
400 1.1.1.2 mrg fi
401 1.1.1.2 mrg
402 1.1.1.2 mrg revision=`$GCC_SVN info | awk '/Revision:/ { print $2 }'`
403 1.1.1.2 mrg branch=`$GCC_SVN info | sed -ne "/^URL:/ {
404 1.1.1.2 mrg s,.*/trunk,trunk,
405 1.1.1.2 mrg s,.*/branches/,,
406 1.1.1.2 mrg s,.*/tags/,,
407 1.1.1.2 mrg p
408 1.1.1.2 mrg }"`
409 1.1.1.2 mrg ;;
410 1.1.1.2 mrg esac
411 1.1 mrg
412 1.1 mrg rm -f LAST_UPDATED gcc/REVISION
413 1.1 mrg {
414 1.1.1.2 mrg date
415 1.1.1.2 mrg echo "`TZ=UTC date` (revision $revision)"
416 1.1 mrg } > LAST_UPDATED
417 1.1 mrg echo "[$branch revision $revision]" > gcc/REVISION
418 1.1 mrg
419 1.1 mrg touch_files_reexec
420